	ORG	0A01H

	LD	D,C
	LD	E,C
	LD	B,H
	LD	H,C
	CALL	DRAW_MIRROR

	LD	B,8
	INC	H
	CALL	DRAW_MIRROR

	LD	E,3
	LD	B,E
	CALL	DRAW_MIRROR

	LD	E,6
	CALL	DRAW_MIRROR

	DEC	E
	LD	D,E
	DEC	L

DRAW_MIRROR:

	PUSH	DE
	PUSH	BC

.DRAW_MIRROR_LOOP:

	CALL	DRAW_MIRROR_H

	PUSH	DE
	LD	A,D
	LD	D,E
	LD	E,A
	CALL	DRAW_MIRROR_H
	POP	DE

	LD	A,D
	ADD	H
	LD	D,A

	LD	A,E
	ADD	L
	LD	E,A

	DJNZ	.DRAW_MIRROR_LOOP

	POP	BC
	POP	DE

	RET

DRAW_MIRROR_H:

	CALL	DRAW_MIRROR_V

	PUSH	DE
	LD	A,E
	NEG	A
	LD	E,A
	CALL	DRAW_MIRROR_V
	POP	DE

	RET

DRAW_MIRROR_V:

	CALL	DRAW_TRANSFORMED

	PUSH	DE
	LD	A,D
	NEG	A
	LD	D,A
	CALL	DRAW_TRANSFORMED
	POP	DE

	RET

DRAW_TRANSFORMED:

	LD	A,E
	ADD	16
	LD	(0B7A1H),A
	LD	A,D
	ADD	20
	LD	(0B7A0H),A
	LD	A,'*'
	JP	0E329H
